/*
rbf_nnn.hh

This C++ header file defines the NML Messages used for command and status by RBF_NN_MODULE
Template Version 1.1

MODIFICATIONS:
Wed Dec 20 17:11:22 EST 2000	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef RBF_NNN_HH
#define RBF_NNN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.
#define NUM_OF_INPUTS 2
#define NUM_OF_OUTPUTS 2
#define NUM_OF_NEURONS 10


// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define RBF_NN_STATUS_TYPE 1000
#define RBF_NN_HALT_TYPE 1001
#define RBF_NN_INIT_TYPE 1002
#define RBF_NN_RUN_TYPE 1003
#define RBF_NN_SET_ADAPTATION_GAIN_TYPE 1004
#define RBF_NN_SET_CENTERS_TYPE 1005
#define RBF_NN_SET_OUT_PARAMS_TYPE 1006
#define RBF_NN_SET_SPREADS_TYPE 1007
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class RBF_NN_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	RBF_NN_STATUS();

	// Constructor used by derived classes
	RBF_NN_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

  double sys_inputs[NUM_OF_INPUTS];
  double sys_outputs[NUM_OF_OUTPUTS];

  double output_errors[NUM_OF_OUTPUTS];

  double adaptation_gain;
  
};

// Command Classes

class RBF_NN_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	RBF_NN_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class RBF_NN_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	RBF_NN_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class RBF_NN_RUN : public RCS_CMD_MSG
{
public:

	//Constructor
	RBF_NN_RUN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class RBF_NN_SET_ADAPTATION_GAIN : public RCS_CMD_MSG
{
public:

	//Constructor
	RBF_NN_SET_ADAPTATION_GAIN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
        // the adaptation gain eta
        double eta;

};

class RBF_NN_SET_CENTERS : public RCS_CMD_MSG
{
public:

	//Constructor
	RBF_NN_SET_CENTERS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double centers[NUM_OF_NEURONS * NUM_OF_INPUTS];
};

class RBF_NN_SET_OUT_PARAMS : public RCS_CMD_MSG
{
public:

	//Constructor
	RBF_NN_SET_OUT_PARAMS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double low_bound;
  double high_bound;

};

class RBF_NN_SET_SPREADS : public RCS_CMD_MSG
{
public:

	//Constructor
	RBF_NN_SET_SPREADS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double spreads[NUM_OF_INPUTS];
};

// Declare NML format function
extern int rbf_nnFormat(NMLTYPE, void *, CMS *);

#endif 	// RBF_NNN_HH
